2008-04-24 12:08:22 +10:00
#!/bin/sh
2019-05-27 08:55:01 +02:00
# SPDX-License-Identifier: GPL-2.0-or-later
2008-04-24 12:08:22 +10:00
#
# Copyright © 2008 IBM Corporation
#
# This script checks prom_init.o to see what external symbols it
# is using, if it finds symbols not in the whitelist it returns
# an error. The point of this is to discourage people from
# intentionally or accidentally adding new code to prom_init.c
# which has side effects on other parts of the kernel.
# If you really need to reference something from prom_init.o add
# it to the list below:
2019-04-26 16:23:26 +00:00
grep " ^CONFIG_KASAN=y $" .config >/dev/null
if [ $? -eq 0 ]
then
MEM_FUNCS = "__memcpy __memset"
else
MEM_FUNCS = "memcpy memset"
fi
2008-04-24 12:08:22 +10:00
WHITELIST = " add_reloc_offset __bss_start __bss_stop copy_and_flush
2019-04-26 16:23:26 +00:00
_end enter_prom $MEM_FUNCS reloc_offset __secondary_hold
2008-04-24 12:08:22 +10:00
__secondary_hold_acknowledge __secondary_hold_spinloop __start
2019-06-03 13:00:51 +00:00
logo_linux_clut224 btext_prepare_BAT
2011-09-19 18:27:58 +00:00
reloc_got2 kernstart_addr memstart_addr linux_banner _stext
2019-09-11 13:34:33 -03:00
__prom_init_toc_start __prom_init_toc_end btext_setup_display TOC.
relocate"
2008-04-24 12:08:22 +10:00
NM = " $1 "
OBJ = " $2 "
ERROR = 0
2019-08-25 22:28:37 +09:00
check_section( )
2018-10-15 13:49:59 +11:00
{
file = $1
section = $2
size = $( objdump -h -j $section $file 2>/dev/null | awk " \$2 == \" $section \" {print \$3} " )
size = ${ size :- 0 }
if [ $size -ne 0 ] ; then
ERROR = 1
echo " Error: Section $section not empty in prom_init.c " >& 2
fi
}
2008-04-24 12:08:22 +10:00
for UNDEF in $( $NM -u $OBJ | awk '{print $2}' )
do
# On 64-bit nm gives us the function descriptors, which have
# a leading . on the name, so strip it off here.
UNDEF = " ${ UNDEF #. } "
if [ $KBUILD_VERBOSE ] ; then
if [ $KBUILD_VERBOSE -ne 0 ] ; then
echo " Checking prom_init.o symbol ' $UNDEF ' "
fi
fi
OK = 0
for WHITE in $WHITELIST
do
if [ " $UNDEF " = " $WHITE " ] ; then
OK = 1
break
fi
done
2008-06-13 07:20:58 +10:00
# ignore register save/restore funcitons
2014-09-13 10:20:17 +02:00
case $UNDEF in
_restgpr_*| _restgpr0_*| _rest32gpr_*)
2008-06-13 07:20:58 +10:00
OK = 1
2014-09-13 10:20:17 +02:00
; ;
_savegpr_*| _savegpr0_*| _save32gpr_*)
2008-06-13 07:20:58 +10:00
OK = 1
2014-09-13 10:20:17 +02:00
; ;
esac
2008-06-13 07:20:58 +10:00
2008-04-24 12:08:22 +10:00
if [ $OK -eq 0 ] ; then
ERROR = 1
echo " Error: External symbol ' $UNDEF ' referenced " \
"from prom_init.c" >& 2
fi
done
2018-10-15 13:49:59 +11:00
check_section $OBJ .data
check_section $OBJ .bss
check_section $OBJ .init.data
2008-04-24 12:08:22 +10:00
exit $ERROR